//
// Project:	Lhogho
// File:	mems.h
//
// Copyright (C) 2007 P.Boytchev
//
// Revision history:
//   2007-06-19	- file created
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#ifndef LHOGHO_MEMS_H
#define LHOGHO_MEMS_H



#define FORMAT_MEM	TEXT("{Mem@%0x}")
#define MEMORY(x)	((x)->unode.v[2])	// pointer to actual memory
#define ATOMS(x)	((x)->unode.a[3])	// pointer to extra atoms
#define IS_MEM(x)	(ID(x)==MEM_ID)


#define MEM_STRUCT_SIZE    0    ///< action: calculate struct size
#define MEM_STRUCT_PACK    1    ///< action: pack atoms to struct
#define MEM_STRUCT_UNPACK  2    ///< action: unpack struct to atoms


extern atom_t new_mem( uint_t size );
extern void delete_mem( atom_t a );
extern void dump_mem( atom_t a, int level );

#endif //LHOGHO_MEMS_H
