//
// Project:	Lhogho
// File:	numbers.h
//
// Copyright (C) 2007 P.Boytchev
//
// Revision history:
//   2007-06-09	- file created from atoms.c
//   2007-06-25 - atom_to_float()
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#ifndef LHOGHO_NUMBERS_H
#define LHOGHO_NUMBERS_H

#include "stdint.h"
#include "stddef.h"
#include "globals.h"
#include "atoms.h"



#define INTEGER(x)	((x)->unode.i[1])
#define FLOAT(x)	((x)->unode.f[1])
#define IS_INTEGER(x)	(ID(x)==INTEGER_ID)
#define IS_FLOAT(x)	(ID(x)==FLOAT_ID)
#define REPCOUNT(x)	((x)->unode.n[2])
#define REPLIMIT(x)	((x)->unode.n[3])



#ifdef WINDOWS
  #define FORMAT_INT		TEXT("%I64d")
  //#define FORMAT_INT		TEXT("%lld")
#else
  #define FORMAT_INT		TEXT("%Ld")
#endif //WINDOWS

#define FORMAT_FP		TEXT("%0.14f")    //TEXT("%f")
#define FORMAT_EXTRA_FP		TEXT("%g")    //TEXT("%f")




#ifdef ADVANCED
  extern int  stats_free;
#endif //ADVANCED




extern atom_t new_integer( int64_t data );
extern atom_t new_float( float64_t data );
extern void delete_numeric( atom_t a );
extern void dump_integer( atom_t a, int level );
extern void dump_integer_const( int a );
extern void dump_float( atom_t a, int level );
extern int  atom_to_float( atom_t a, float64_t *np );
extern int atom_to_int( atom_t a, int64_t* np );
extern int atom_to_integer( atom_t a, int* np );

#if defined(DEBUG_RUNTIME_ATOMS) || defined(DEBUG_COMPILETIME_ATOMS)
extern void dump_atom_address( atom_t a );
#endif


#endif //LHOGHO_NUMBERS_H
