//
// Project:	Lhogho
// File:	translate_bg.h
//
// Copyright (C) 2011 P.Boytchev
// Translation by P. Boytchev
//
// Revision history:
//   2011-02-11	- file created from old translate.h
//   2011-10-07 - Removed TR_WARNING_UNSUPPORTED_COMPILER, because GCC 4+ is now supported
//   2011-10-14 - Added RUNMACRO
//   2011-12-02 - Added TR_ERROR_OUT_OF_MEM
//   
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


#ifndef LHOGHO_TRANSLATE_BG_H
#define LHOGHO_TRANSLATE_BG_H


// ===========================================================
/// \def	TR_LHOGHO_CAPTION
/// \brief	Lhogho welcome message
// ===========================================================
#define TR_LHOGHO_CAPTION	                \
  TEXT("LHOGHO - Компилатор за LOGO ["	        \
	OS_NAME "-" PROCESSOR_NAME "(Bg), "	\
	__DATE__ "]\n"				\
      "\n")



// ===========================================================
/// \def	ADVANCED_OPTIONS
/// \brief	text describing the advanced options
// ===========================================================
#ifdef ADVANCED
#define ADVANCED_OPTIONS "Допълнителни опции:\n"
#else
#define ADVANCED_OPTIONS "Изключени опции:\n"
#endif




// ===========================================================
/// \def	TR_OPTION_HELP
/// \brief	message to appear for -h and --help option
// ===========================================================
#define TR_OPTION_HELP TEXT(						\
    "Употреба:\n"								\
    "  lhogho [опция] [опция] ... име-на-файл [аргументи]\n"		\
    "\n"								\
    "Опции:\n"							\
    "  -h     --help                показва това съобщение\n"		\
    "  -x     --executable          създава изпълним файл\n"		\
    "  -xc    --executable-compiler създава изпълним файл с вградено Lhogho\n"	\
    "  -ci    --case-insensitive    игнориране на главни букви\n"	\
    "  -t     --traditional         включва в традиционен режим\n"	\
    "\n"								\
    ADVANCED_OPTIONS							\
    "  -Za    --Zassembler          показва кода на асемблер\n"		\
    "  -Zm    --Zmemory             статистика на паметта\n"		\
    "  -Zmad  --Zmemory-all-details детайлна статистика на паметта\n"	\
    "  -Zrt   --Zrun-time           изчисленията в реално време\n"		\
    "  -Zt    --Ztree               синтактичните дървета\n"	\
    "  -Zv    --Zvariables          всички променливите\n"			\
    "  -Zuv   --Zuser-variables     потребителски променливи\n"		\
    "" )




// ===========================================================
/// \def	TR_PRIMITIVES
/// \brief	translations of primitives
// ===========================================================
#define TR_PRIMITIVES	TEXT(				                 \
  " false true to end toplevel system error"                 \
  " * / + - = < > <= >= <> and or not "	                     \
  " first butfirst bf firsts butfirsts bfs"                  \
  " last butlast bl item "                                   \
  " word list sentence se fput lput "                        \
  " word? wordp list? listp number? numberp empty? emptyp "  \
  " equal? equalp notequal? notequalp before? beforep "      \
  " less? lessp greater? greaterp lessequal? lessequalp "    \
  " greaterequal? greaterequalp member? memberp count "      \
  " char ascii lowercase uppercase member parse runparse "   \
  " sum difference minus product quotient remainder "        \
  " int round sqrt power exp log10 ln abs "                  \
  " pi sin radsin cos radcos arctan radarctan "              \
  " iseq rseq random rerandom pick "                         \
  " lshift ashift bitand bitor bitxor bitnot "               \
  " print pr ? show type form format "                       \
  " if ifelse repeat repcount while do.while until do.until "\
  " run forever ignore stop make name output op maybeoutput local thing bye " \
  " wait tag goto defined? definedp primitive? primitivep  " \
  " name? namep procedure? procedurep "			             \
  " for case cond text fulltext define load commandline "    \
  " printdepthlimit printwidthlimit fullprintp caseignoredp "\
  " logoplatform logoversion logodialect "			         \
  " catch throw error apply "					             \
  " test iftrue ift iffalse iff "			                 \
  " backslashed? backslashedp "					             \
  " remdup remove reverse rawascii"                          \
  " substring? substringp substring gensym combine quoted"             \
  " runresult runmacro " \
  " libload libfree " \
  " packsize pack unpack packaddr packto funcaddr " \
  " openfile closefile readpack writepack " \
  " external internal _int3 _stackframe _stackframeatom " \
  " readchar rc readchars rcs readrawline readword rw readlist rl " \
  " getenv getenvs eof? eofp " \
  " " )


// ===========================================================
/// \name Error messages
// ===========================================================
// @{
#define TR_ERROR_INCOMPLETE_PAIR    TEXT("Липсва съответния елемент")
#define TR_ERROR_EMPTY_EXPRESSION   TEXT("Празен израз")
#define TR_ERROR_CROWDED_EXPRESSION TEXT("Пренаселен израз")
#define TR_ERROR_MISSING_LEFTS      TEXT("Липсват някои от данните от ляво")
#define TR_ERROR_MISSING_RIGHTS     TEXT("Липсват някои от данните от дясно")
#define TR_ERROR_EMPTY_TO_END       TEXT("Empty TO..END definition")
#define TR_ERROR_MISSING_NAME       TEXT("Missing name of a TO..END definition")
#define TR_ERROR_DUPLICATE_INPUT    TEXT("Duplicate name of input")
#define TR_ERROR_UNKNOWN_OPTION     TEXT("Неизвестна опция")
#define TR_ERROR_CROWDED_SOURCES    TEXT("Two or more input source files")
#define TR_ERROR_OS_ERROR           TEXT("OS Error")
#define TR_ERROR_INCOMPATIBLE_REDEFINITION  TEXT("Incompatible TO..END redefinition")
#define TR_ERROR_NOT_A_NUMBER       TEXT("Не е число")
#define TR_ERROR_UNUSED_VALUE       TEXT("Неизползвана стойност")
#define TR_ERROR_MISSING_VALUE      TEXT("Липсва стойност")
#define TR_ERROR_DO_NOT_KNOW        TEXT("Не знам как да направя това")
#define TR_ERROR_UNKNOWN_VAR        TEXT("Reference to unknown variable")
#define TR_ERROR_BOOLEAN_EXPECTED   TEXT("Boolean expression expected")
#define TR_ERROR_NOT_AN_INTEGER     TEXT("Не е цяло число")
#define TR_ERROR_NOT_A_LIST         TEXT("Не е списък")
#define TR_ERROR_NOT_A_WORD         TEXT("Не е дума")
#define TR_ERROR_INCOMPATIBLE_DATA  TEXT("Value not compatible with function requirements")
#define TR_ERROR_TOO_BIG_NUMBER     TEXT("Много голямо число")
#define TR_ERROR_TOO_SMALL_NUMBER   TEXT("Много малко число")
#define TR_ERROR_NOT_A_VAR          TEXT("Не е променлива")
#define TR_EXIT_BY_BYE		    TEXT("Bye")
#define TR_EXIT_BY_THROW_TOPLEVEL   TEXT("Thrown to toplevel")
#define TR_EXIT_BY_THROW_SYSTEM     TEXT("Thrown to system")
#define TR_EXIT_BY_THROW_ERROR      TEXT("Thrown by error")
#define TR_EXIT_BY_THROW_USER_ERROR	TEXT("Thrown by error")
#define TR_EXIT_BY_THROW_TAG		TEXT("Uncatched throw")
#define TR_EXIT_BY_THROW_TAG_VALUE	TEXT("Uncatched throw")
#define TR_ERROR_NOT_A_TAG		TEXT("Not a tag")
#define TR_ERROR_NOT_A_USER_FUNCTION	TEXT("Not a user-defined function")
#define TR_ERROR_VAR_HAS_NO_VALUE   TEXT("Variable has no value")
#define TR_ERROR_NOT_A_FUNCTION     TEXT("Not a command or a function")
#define TR_ERROR_NOT_A_LIST_CONST   TEXT("Not a list constant")
#define TR_ERROR_NOT_A_WORD_CONST   TEXT("Not a word constant")
#define TR_ERROR_MISSING_FOR_LIMITS TEXT("Missing initial or final limit")
#define TR_ERROR_NOT_A_TYPE_NAME    TEXT("Not a name of a supported type")
#define TR_ERROR_BAD_PROTOTYPE      TEXT("Not a valid function prototype")
#define TR_ERROR_NOT_A_MEM	    TEXT("Not a memory block or packed data")
#define TR_ERROR_OUT_OF_MEM	    TEXT("Out of memory")
//#define TR_WARNING_UNSUPPORTED_COMPILER     TEXT("This Lhogho is compiled with unsupported compiler")

// @}

#endif //LHOGHO_TRANSLATE_BG_H
