//
// Project:	Lhogho
// File:	translate_de.h
//
// Copyright (C) 2011-2012 P.Boytchev
// Translation by Stephan Vogel
//
// Revision history:
//   2011-02-11	- file created from old translate.h
//   2011-10-07 - Removed TR_WARNING_UNSUPPORTED_COMPILER, because GCC 4+ is now supported
//   2011-10-14 - Added RUNMACRO
//   2011-12-02 - Added TR_ERROR_OUT_OF_MEM
//   2011-12-18 - Translation into German
//   2012-01-02 - File structure fixed
//   2012-01-05 - More synonyms for primitives
//   
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


#ifndef LHOGHO_TRANSLATE_DE_H
#define LHOGHO_TRANSLATE_DE_H


// ===========================================================
/// \def	TR_OPTION_HELP
/// \brief	message to appear for -h and --help option
// ===========================================================
#define TR_OPTIONS  TEXT( \
  " |-h|    |--help|                |--Hilfe|                       |drucke diese Hilfemeldung| "\
  " |-x|    |--executable|          |--ausführen|                   |ausführbare Datei schaffen| "\
  " |-xc|   |--executable-compiler| |--compilieren|                 |Lhogho-Einbettung in ausführbare Datei| "\
  " |-ci|   |--case-insensitive|    |--Schriftmodus-unempfindlich|  |umschalten zum unempfindlichen Modus - Schriftsatz| "\
  " |-t|    |--traditional|         |--traditionell|                |umschalten zum traditionellen Modus| "\
  " |-Za|   |--Zassembler|          |--ZAssembler|                  |dump Assemblercode| "\
  " |-Zm|   |--Zmemory|             |--ZSpeicher|                   |dump Speicherstatistik| "\
  " |-Zmad| |--Zmemory-all-details| |--ZSpeicher-alle-Details|      |dump Speicherstatistik - alle Details| "\
  " |-Zrt|  |--Zrun-time|           |--ZLaufzeit|                   |dump Laufzeit-Evaluationen| "\
  " |-Zt|   |--Ztree|               |--ZBaum|                       |dump abstrakte Syntax-Bäume| "\
  " |-Zv|   |--Zvariables|          |--ZVariablen|                  |dump Variablen| "\
  " |-Zuv|  |--Zuser-variables|     |--ZBenutzer-Variablen|         |dump Benutzer-Variablen| "\
  " " )

  // Üüäß
#define TR_HELP_TEXTS TEXT( \
  " |LHOGHO - Der LOGO Compiler| "\
  " |Usage:\n  lhogho [Option] [Option] ... Dateiname [Argumente]\n\nOptionen:\n| "\
  " |\nFortgeschrittene Optionen:| "\
  " |\nNicht unterstützte Optionen:| "\
  " " )


// ===========================================================
/// \def	TR_PRIMITIVES
/// \brief	translations of primitives
// ===========================================================
#define TR_PRIMITIVES	TEXT(				                 \
  " falsch wahr lerne pr ende ausstieg system fehler "                 \
  " * / + - = < > <= >= <> alle? und eines? oder nicht? "	                     \
  " erstes er ohneerstes oe alleerstes aer ohneerstesalle oea "                  \
  " letztes lz ohneletztes ol element el "                                   \
  " wort liste satzbilden satz miterstem me mitletztem ml "                        \
  " wort? wortp liste? listep zahl? zahlp leer? leerp "  \
  " gleich? gleichp ungleich? ungleichp vorher? vorherp "      \
  " kleiner? kleinerp größer? größerp kleinergleich? kleinergleichp "    \
  " größergleich? größergleichp element? el? elementp elp länge anzahl "      \
  " zeichen asc klein kleinschrift groß großschrift elementab parsatz tueparsatz "   \
  " summe differenz minus produkt quotient rest "        \
  " int runde qw potenz exp log10 ln abs "                  \
  " pi sin radsin cos radcos arctan radarctan "              \
  " iseq lseq zz zufallszahl sz startezufall picke "                         \
  " lwechsel awechsel bitund bitoder bitxoder bitnicht "               \
  " druckezeile dz ? zg drucke dr form format zeitformat zeitzone "                       \
  " wenn wennsonst wiederhole wh whzahl .solange führeaus.solange .bis führeaus.bis "\
  " tue andauernd ignoriere rückkehr rk setze name rückgabe rg magseinrückgabe lokal wert ade " \
  " warte schildchen gehe def? defp grundwort? grundwortp  " \
  " name? namep prozedur? prozedurp "			             \
  " für.bis schriftsatz cond text volltext definiere def lade kommandozeile "    \
  " druckelistentiefe druckelistenmächtigkeit vollelistentiefep großkleinschrift.ignoriertp "\
  " logoplattform logoversion logodialekt "			         \
  " fange wirf fehler benutze "					             \
  " test wennwahr ww wennfalsch wf "			                 \
  " backslash? backslashp "					             \
  " entfdup entferne umkehrung ascii "                          \
  " substring? substringp substring ginsym kombinieren zitiert "             \
  " tuewert tuemakro " \
  " bibliothekladen bibliothekfrei " \
  " packgröße packen entpacken dataadr packenzu funktionadr " \
  " öffnedatei schließedatei liespackung readinblock schreibepackung " \
  " extern intern _int3 _stackrahmen _stackrahmenatom " \
  " lieszeichen lzeichen lieszeichenkette lzk liestasten lieswort lw liesliste ll " \
  " gibumgebungsvariable gibumgebungsvariablen dateiende? dateiendep " \
  " aktuellerordner setzeordner löscheordner ordner? ordnerp " \
  " umbenennenordner ordner ändereordner files löschedatei vgdatei Datei? Dateip " \
  " umbenennendatei dateigröße dateizeiten öffnenlesen öffnenschreiben öffnenanhängen öffnenaktualisieren " \
  " setzelesen setzeschreiben leser schreiber allesoffen schließealles " \
  " leseort setzeleseort schreibeort setzeschreibeort dribble nodribble " \
  " " )


// ===========================================================
/// \name Error messages
// ===========================================================
// @{
#define TR_ERRORS TEXT( \
  " |Der andere Zählerteil wird vermisst| "        /*ERROR_INCOMPLETE_PAIR*/\
  " |Leerer Ausdruck| "                            /*ERROR_EMPTY_EXPRESSION*/\
  " |Überfüllter Ausdruck| "                       /*ERROR_CROWDED_EXPRESSION*/\
  " |Einige linke Eingaben werden vermisst| "      /*ERROR_MISSING_LEFTS*/\  
  " |Einige rechte Eingaben werden vermisst| "     /*ERROR_MISSING_RIGHTS*/\
  " |Leere PR..ENDE-Definition| "                  /*ERROR_EMPTY_TO_END*/\
  " |Name vermisst einer PR..ENDE-Definition| "    /*ERROR_MISSING_NAME*/\
  " |Doppelter Name der Eingabe| "                 /*ERROR_DUPLICATE_INPUT*/\
  " |Unbekannte Option| "                          /*ERROR_UNKNOWN_OPTION*/\
  " |Zwei oder mehr Quelldateien - Eingabe| "      /*ERROR_CROWDED_SOURCES*/\
  " |Systemfehler| "                               /*ERROR_OS_ERROR*/\
  " |Inkompatible PR..ENDE-Definition| "           /*ERROR_INCOMPATIBLE_REDEFINITION*/\
  " |Keine Zahl| "                                 /*ERROR_NOT_A_NUMBER*/\
  " |Nicht benutzter Wert| "                       /*ERROR_UNUSED_VALUE*/\
  " |Wert vermisst| "                              /*ERROR_MISSING_VALUE*/\
  " |Was soll geschehen mit| "                     /*ERROR_DO_NOT_KNOW*/\
  " |Referenz zu unbekannter Variable| "           /*ERROR_UNKNOWN_VAR*/\
  " |Boolescher Ausdruck erwartet| "               /*ERROR_BOOLEAN_EXPECTED*/\
  " |Keine ganze Zahl| "                           /*ERROR_NOT_AN_INTEGER*/\
  " |Keine Liste| "                                /*ERROR_NOT_A_LIST*/\
  " |Kein Wort| "                                  /*ERROR_NOT_A_WORD*/\
  " |Wert ist nicht kompatibel zu den Erfordernissen der Funktion| " /*ERROR_INCOMPATIBLE_DATA*/\
  " |Numerischer Wert ist zu groß| "               /*ERROR_TOO_BIG_NUMBER*/\
  " |Numerischer Wert ist zu klein| "              /*ERROR_TOO_SMALL_NUMBER*/\
  " |Keine Variable| "                             /*ERROR_NOT_A_VAR*/\
  " |Ade| "                                        /*EXIT_BY_BYE*/\
  " |Herausgeworfen zum Ausstieg| "                /*EXIT_BY_THROW_TOPLEVEL*/\
  " |Herausgeworfen zum System| "                  /*EXIT_BY_THROW_SYSTEM*/\
  " |Herausgeworfen durch Fehler| "                /*EXIT_BY_THROW_ERROR*/\
  " |Herausgeworfen durch Benutzerfehler| "        /*EXIT_BY_THROW_USER_ERROR*/\
  " |Kein Fange - Schildchen/Etikett| "            /*EXIT_BY_THROW_TAG*/\
  " |Kein Fange - Schildchenwert/Etikettwert| "    /*EXIT_BY_THROW_TAG_VALUE*/\
  " |Kein Schildchen/Etikett| "                    /*ERROR_NOT_A_TAG*/\
  " |Keine vom Benutzer definierte Funktion| "     /*ERROR_NOT_A_USER_FUNCTION*/\
  " |Variable hat keinen Wert| "                   /*ERROR_VAR_HAS_NO_VALUE*/\
  " |Kein Befehl oder keine Funktion| "            /*ERROR_NOT_A_FUNCTION*/\
  " |Keine Liste-Konstante| "                      /*ERROR_NOT_A_LIST_CONST*/\
  " |Keine Wort-Konstante| "                       /*ERROR_NOT_A_WORD_CONST*/\
  " |Untere oder obere Grenze vermisst| "          /*ERROR_MISSING_FOR_LIMITS*/\
  " |Kein Name von einem unterstützten Datentyp| " /*ERROR_NOT_A_TYPE_NAME*/\
  " |Kein gültiger Funktionsprototyp| "            /*ERROR_BAD_PROTOTYPE*/\
  " |Kein Speicherblock oder keine gepackten Daten| " /*ERROR_NOT_A_MEM*/\
  " |Speicherüberlauf| "                           /*ERROR_OUT_OF_MEM*/\
  " |File is not opened| "                         /*ERROR_FILE_NOT_OPENED*/\
  " |Not a block or a block definition list| "     /*ERROR_NOT_BLOCK_OR_DEF*/\
  " " )
// @}

#endif //LHOGHO_TRANSLATE_DE_H
