//
// Project:	Lhogho
// File:	words.h
//
// Copyright (C) 2007 P.Boytchev
//
// Revision history:
//   2007-06-09	- file created from atoms.h
//   2007-06-17 - fixed bug #1738571 "Invalid pointer in Ubuntu binary"
//   2007-09-01 - FULLPRINTP
//   2007-10-06 - create_word
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#ifndef LHOGHO_WORDS_H
#define LHOGHO_WORDS_H




#define STRING(x)	((x)->unode.c[2])
#define WORD(x)		((x)->unode.a[3])
#define LENGTH(x)	((x)->unode.u[1] >> 8)
#define IDLENGTH(x)	((x)->unode.u[1])
#define IS_WORD(x)	(ID(x)==WORD_ID)
#define IS_SUBWORD(x)	(ID(x)==SUBWORD_ID)
#define IS_ANY_WORD(x)	((ID(x)==WORD_ID)||(ID(x)==SUBWORD_ID))

#define WORD_SIZE	256*256*256		///< max word length (in chars)


extern int full_print_p;
extern atom_t false_true[2];


extern atom_t new_word( chars_t string, uint_t length );
extern atom_t new_subword( atom_t word, chars_t string, uint_t length );
extern atom_t create_word(int buff_len);
extern void   delete_word( atom_t a );
extern void   delete_subword( atom_t a );
extern void   dump_word( atom_t a, int level );
extern atom_t read_word( chars_t filename );
extern void   write_word( atom_t word, chars_t filename );
extern int    same_words( atom_t a, atom_t b );
extern atom_t decode_word( unsigned char* buffer, int size, int dealc );
extern int    atom_to_boolean( atom_t a, int* np );
extern int    atom_to_string(atom_t a, chars_t buff, int * buff_len);
extern atom_t atom_to_word( atom_t data );
extern atom_t atom_to_real_word( atom_t data );

extern int same_strings( int ci, chars_t sa, chars_t sb, int n );

#endif //LHOGHO_WORDS_H
