#include <string.h>
#include <stdlib.h>
#include "../core/compiler.h"
#include "../core/unicode.h"


#ifdef WINNT
#define Java_JNIConnector_callCompiler _Java_JNIConnector_callCompiler
#endif

#include "JNIConnector.h"

#ifdef UNICODE_CHARS
#define GetStringCharsJni       GetStringChars
#define NewStringJni(X, Y, Z)   NewString(X, Y, Z)
#define ReleaseStringJni        ReleaseStringChars
#else
#define GetStringCharsJni       GetStringUTFChars
#define NewStringJni(X, Y, Z)   NewStringUTF(X, Y)
#define ReleaseStringJni        ReleaseStringUTFChars
#endif

jobject caller;
JNIEnv* calling_env;

void outter_func(chars_t buffer, int size)
{   
    if (size < 0)
    {
        size = STRLEN (buffer);
    }
    jstring jres = (*calling_env)->NewStringJni(calling_env, buffer, size);
    jclass cls = (*calling_env)->GetObjectClass(calling_env, caller);
    jmethodID jPrintResult = (*calling_env)->GetMethodID(calling_env, cls, "printCompilerResult", "(Ljava/lang/String;)V");
    if (jPrintResult == NULL)
    {
		fprintf (stderr, "Cannot find printCompilerResult function\n");
    }
	else
    {
	    (*calling_env)->CallVoidMethod (calling_env, caller, jPrintResult, jres);
    }
}

JNIEXPORT void JNICALL Java_JNIConnector_callCompiler(JNIEnv *env, jobject obj, jstring command) {
    chars_t str1 = (chars_t)(*env)->GetStringCharsJni(env, command, 0);
    init_compiler(outter_func,0);
    caller = obj;
    calling_env = env;
    run_source(str1);

    (*env)->ReleaseStringJni(env, command, str1);
    finit_compiler();
}

int main() { return 0; }
