//
// Project:	Lhogho
// File:	lhogho.c
//
// Copyright (C) 2007 P.Boytchev
//
// Revision history:
//   2006-10-13	- file created
//   2007-05-17 - added license info
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "string.h"

#include "..//core//atoms.h"
#include "..//core//unicode.h"
#include "..//core//mems.h"
#include "..//core//vars.h"
#include "..//core//lists.h"
#include "..//core//options.h"
#include "..//core//compiler.h"
#include "..//core//errors.h"
#include "..//core//external.h"


#ifdef __GNUC__

#define Java_TestFrame_f _Java_TestFrame_f
#define Java_TestFrame_g _Java_TestFrame_g
#define Java_TestFrame_h _Java_TestFrame_h
#define Java_TestFrame_adr _Java_TestFrame_adr
#define Java_TestFrame_concat _Java_TestFrame_concat
#define Java_TestFrame_RunCompilerGUI _Java_TestFrame_RunCompilerGUI

#endif

#include "TestFrame.h"
#include "jni.h"
#include <string.h>


//===================================================
/// \fn JNIEXPORT void JNICALL Java_TestFrame_f( )
/// \brief	initializes the Atoms module
///
/// Creates a data pool for all atoms and creates one
/// special atom representing the empty list.
//===================================================

JNIEXPORT void JNICALL Java_TestFrame_f(JNIEnv* env, jobject o, jstring jMsg)
{
	
	const char* msg=(*env)->GetStringUTFChars(env, jMsg,0);
	printf("C++ <-- %s\n",msg);
	fflush(stdout);
//	env->ReleaseStringUTFChars(jMsg,msg);	
	fflush(stdout);
}

/*  bez uni code
JNIEXPORT jint JNICALL Java_TestFrame_RunCompilerGUI(JNIEnv* env, jobject o, jstring jMsg)
{
	const char* msg=(*env)->GetStringUTFChars(env, jMsg,0);
	printf("Printirane v C na vuvedenia v JAVA tekst: %s\n",msg);
	fflush(stdout);
	return 1;
}
*/


//===================================================
/// \fn JNIEXPORT void use_stdout( )
/// \brief	prints the rezult of the program. 
/// 
/// If the string ends with zero, than prints it. 
/// Else, print len chars from the string.
//===================================================

void use_stdout( chars_t string, int len )
{
  //if( len==-1 ) len=STRLEN(string);
  //for( ; len>0; len-- ) PUTCHAR( *string++, stdout );
	printf("\nBOZA\n");
}



//===================================================
/// \fn JNIEXPORT void JNICALL Java_TestFrame_RunCompilerGUI( )
/// \brief	recieves a string from the JAVA and calls the compiler. 
/// 
/// The string is a Logo program.
/// The compiler runs over the string and returs a value - true,false or error.
//===================================================

JNIEXPORT jint JNICALL Java_TestFrame_RunCompilerGUI(JNIEnv* env, jobject o, jstring jMsg)
{
	const char* msg=(*env)->GetStringUTFChars(env, jMsg,0);
	unsigned char x;
	int i=0, result;
	const wchar_t * buf = malloc(10000*sizeof(wchar_t));
	wchar_t * buf1;
	int l = strlen(msg) + 1;
	unsigned short int * bufff = malloc(l * sizeof(char));
	char* p = (char*) bufff;
	
	
	l*=2;
	for (i = 0; i < l; i++) {
		p[i] = 0;
	}

	i = 0;
	while (*msg) {
		p[i++] = *(msg++);
		i++;
	}
	printf("V .dll:%S\n\n", bufff);
	fflush(stdout);

	// buf = (*env)->GetStringChars(env, jMsg,&x);
	// int argc = 2;
	//	char* argv[2] = {"test_compiler.lgo","test_compiler.lgo"};


	init_compiler( use_stdout );
	printf("\n\nsled init_compiler\n");
	fflush(stdout);
	// set_options( argc, argv );
/*
	result = compile_from_options( );
	if( !result && !option_make_executable && IS_NOT_EMPTY(BODY(root)) ) 
		result = run_function( root );
*/
	
	result = run_source(bufff);
	finit_compiler( );


	return result;
}


/*
int main( int argc, char * argv[] )
{

	
  printf("Lhogho\n");
  init_atoms();
  init_vars();

  atom_t a,b,c,d,e;
  int i,j,k;
  a = empty_list;
  b = empty_list;
  c = empty_list;
  d = empty_list;
  e = empty_list;

  a = read_word( TEXT("test.lgo") );

  //a = new_word( L"before[in1 in2[in3a in3b][in4a[]in4c][][[]]last]after", UNKNOWN );

  b = trim_shell_comment( a );
  c = function_syntax_tree( root, b, 1 );

  //printf("----------\n");
  //dumpln(c);
  //printf("----------\n");

  //dump( root );

 to_exit:
  deuse(a);
  deuse(b);
  deuse(c);
  deuse(d);
  deuse(e);
  finit_vars();
  finit_atoms();
  
  return 0;
}

  */
