
import java.util.Calendar;

/*
 * GuiPrototype.java
 *
 */
 
 class GuiTask extends Thread{
    public GuiTask(GuiPrototype gui) {
        this.gui = gui;
        this.connector = new JNIConnector(gui);
    }
 
    @Override
    public void run() {
        gui.disableCall();
        connector.callCompiler(command);
        gui.enableCall();
    }
    
    public void setCommand(String cmd) {
        command = cmd;
    }
    
    private JNIConnector connector;
    private GuiPrototype gui;
    private String command = "";
 }

/**
 *
 * @author  peter.armyanov
 */
public class GuiPrototype extends javax.swing.JFrame {

    /** Creates new form GuiPrototype */
    public GuiPrototype() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jTextNumber = new javax.swing.JTextField();
    jTextIncCnt = new javax.swing.JTextField();
    jTextIncRes = new javax.swing.JTextField();
    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jButtonIncrement = new javax.swing.JButton();
    jLabel4 = new javax.swing.JLabel();
    jTextConcatText = new javax.swing.JTextField();
    jLabel5 = new javax.swing.JLabel();
    jTextConcatTimes = new javax.swing.JTextField();
    jButtonConcat = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTextAreaConcat = new javax.swing.JTextArea();
    jScrollPane2 = new javax.swing.JScrollPane();
    jTextAreaSource = new javax.swing.JTextArea();
    jButtonCallLhogho = new javax.swing.JButton();
    jScrollPane3 = new javax.swing.JScrollPane();
    jTextAreaResult = new javax.swing.JTextArea();
    jLabel6 = new javax.swing.JLabel();
    jLabel7 = new javax.swing.JLabel();
    jLabel8 = new javax.swing.JLabel();
    lblTime = new javax.swing.JLabel();
    jMenuBar1 = new javax.swing.JMenuBar();
    jMenu1 = new javax.swing.JMenu();
    jMenu2 = new javax.swing.JMenu();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

    jLabel1.setText("Start Number");

    jLabel2.setText("Increment count");

    jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel3.setText("Result");

    jButtonIncrement.setText("Increment");
    jButtonIncrement.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jButtonIncrementMouseClicked(evt);
      }
    });

    jLabel4.setText("Text");

    jLabel5.setText("Times to concat");

    jButtonConcat.setText("Concat");
    jButtonConcat.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jButtonConcatMouseClicked(evt);
      }
    });

    jTextAreaConcat.setColumns(20);
    jTextAreaConcat.setRows(5);
    jScrollPane1.setViewportView(jTextAreaConcat);

    jTextAreaSource.setColumns(20);
    jTextAreaSource.setRows(5);
    jScrollPane2.setViewportView(jTextAreaSource);

    jButtonCallLhogho.setText("Sent to Lhogho");
    jButtonCallLhogho.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jButtonCallLhoghoMouseClicked(evt);
      }
    });

    jTextAreaResult.setColumns(20);
    jTextAreaResult.setLineWrap(true);
    jTextAreaResult.setRows(5);
    jScrollPane3.setViewportView(jTextAreaResult);

    jLabel6.setText("Program code");

    jLabel7.setText("Result");

    jLabel8.setText("Time:");

    jMenu1.setText("File");
    jMenuBar1.add(jMenu1);

    jMenu2.setText("Edit");
    jMenuBar1.add(jMenu2);

    setJMenuBar(jMenuBar1);

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 450, Short.MAX_VALUE)
          .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 450, Short.MAX_VALUE)
          .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 450, Short.MAX_VALUE)
          .addComponent(jLabel6)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addComponent(jLabel7)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 315, Short.MAX_VALUE)
            .addComponent(jButtonCallLhogho))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
              .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                  .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                  .addComponent(jTextNumber)
                  .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                  .addGroup(layout.createSequentialGroup()
                    .addGap(35, 35, 35)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                      .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                      .addComponent(jTextIncCnt)))
                  .addGroup(layout.createSequentialGroup()
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(lblTime, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
              .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel4)
                .addGap(18, 18, 18)
                .addComponent(jTextConcatText)))
            .addGap(35, 35, 35)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
              .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                .addComponent(jTextConcatTimes, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
              .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
              .addComponent(jTextIncRes, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE))
            .addGap(27, 27, 27)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
              .addComponent(jButtonConcat, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
              .addComponent(jButtonIncrement, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel1)
          .addComponent(jLabel2)
          .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(18, 18, 18)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jTextNumber, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jTextIncCnt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jButtonIncrement)
          .addComponent(jTextIncRes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel8)
          .addComponent(lblTime))
        .addGap(22, 22, 22)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
            .addComponent(jLabel4)
            .addComponent(jTextConcatText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jLabel5)
            .addComponent(jTextConcatTimes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
          .addComponent(jButtonConcat))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(jLabel6)
        .addGap(2, 2, 2)
        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(jButtonCallLhogho)
          .addComponent(jLabel7))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 151, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );

    pack();
  }// </editor-fold>//GEN-END:initComponents
    private void jButtonIncrementMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButtonIncrementMouseClicked
        int numb = Integer.parseInt(jTextNumber.getText());
        int times = Integer.parseInt(jTextIncCnt.getText());
        long start = Calendar.getInstance().getTimeInMillis();
        int res = repeatIncrement(numb, times);
        jTextIncRes.setText(String.valueOf(res));
        long duration = Calendar.getInstance().getTimeInMillis() - start;
        lblTime.setText(duration + " ms");
    }//GEN-LAST:event_jButtonIncrementMouseClicked

    private void jButtonConcatMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButtonConcatMouseClicked
        String str = jTextConcatText.getText();
        int times = Integer.parseInt(jTextConcatTimes.getText());
        long start = Calendar.getInstance().getTimeInMillis();
        String res = repeatConcat(str, times);
        jTextAreaConcat.setText(res + " ");
        long duration = Calendar.getInstance().getTimeInMillis() - start;
        lblTime.setText(duration + " ms");
    }//GEN-LAST:event_jButtonConcatMouseClicked

    private void jButtonCallLhoghoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButtonCallLhoghoMouseClicked
        String str = jTextAreaSource.getText();
        jTextAreaResult.setText("");
        start = Calendar.getInstance().getTimeInMillis();
        sendCommand(str);
    }//GEN-LAST:event_jButtonCallLhoghoMouseClicked

    // JNI Connectors -----------------------------------------
    private JNIConnector connector = new JNIConnector(this);
    
    private int repeatIncrement(int number, int times) {
        while (times-- != 0) {
            number = connector.incrementInt(number);
        }

        return number;
    }

    private String repeatConcat(String s, int times) {
        String res = s;
        while (times-- != 0) {
            res = connector.concatStrings(res, s);
        }

        return res;
    }

    private void sendCommand(String command) {
        GuiTask task = new GuiTask(this);
        task.setCommand(command);
        task.start();
    }

    public void disableCall() {
        jButtonCallLhogho.setEnabled(false);
        start = Calendar.getInstance().getTimeInMillis();
    }
    
    public void enableCall() {
        jButtonCallLhogho.setEnabled(true);
        long duration = Calendar.getInstance().getTimeInMillis() - start;
        lblTime.setText(duration + " ms");
    }
    
    long start;

    // JNI Connectors END -------------------------------------
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton jButtonCallLhogho;
  private javax.swing.JButton jButtonConcat;
  private javax.swing.JButton jButtonIncrement;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JLabel jLabel5;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JLabel jLabel7;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JMenu jMenu1;
  private javax.swing.JMenu jMenu2;
  private javax.swing.JMenuBar jMenuBar1;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JScrollPane jScrollPane2;
  private javax.swing.JScrollPane jScrollPane3;
  private javax.swing.JTextArea jTextAreaConcat;
  javax.swing.JTextArea jTextAreaResult;
  private javax.swing.JTextArea jTextAreaSource;
  private javax.swing.JTextField jTextConcatText;
  private javax.swing.JTextField jTextConcatTimes;
  private javax.swing.JTextField jTextIncCnt;
  private javax.swing.JTextField jTextIncRes;
  private javax.swing.JTextField jTextNumber;
  private javax.swing.JLabel lblTime;
  // End of variables declaration//GEN-END:variables
}
