#include <string.h>
#include <stdlib.h>
#include "../../core/compiler.h"
#include "../../core/unicode.h"


#ifdef WINNT
#define Java_JNIConnector_incrementInt _Java_JNIConnector_incrementInt
#define Java_JNIConnector_concatStrings _Java_JNIConnector_concatStrings
#define Java_JNIConnector_callCompiler _Java_JNIConnector_callCompiler
#endif

#include "JNIConnector.h"

#ifdef UNICODE_CHARS
#define GetStringCharsJni       GetStringChars
#define NewStringJni(X, Y, Z)   NewString(X, Y, Z)
#define ReleaseStringJni        ReleaseStringChars
#else
#define GetStringCharsJni       GetStringUTFChars
#define NewStringJni(X, Y, Z)   NewStringUTF(X, Y)
#define ReleaseStringJni        ReleaseStringUTFChars
#endif

JNIEXPORT jint JNICALL Java_JNIConnector_incrementInt(JNIEnv *env, jobject obj, jint num) {
    return ++num;
}

JNIEXPORT jstring JNICALL Java_JNIConnector_concatStrings(JNIEnv *env, jobject obj, jstring s1, jstring s2) {
    const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
    const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
    int l1 = strlen(str1);
    int l2 = strlen(str2);
    char *res = (char*) malloc(sizeof(char) * (l1 + l2 + 1));
    jstring jres;
    
    strcpy(res, str1);
    strcat(res, str2);
    
    (*env)->ReleaseStringUTFChars(env, s1, str1);
    (*env)->ReleaseStringUTFChars(env, s2, str2);
    
    jres = (*env)->NewStringUTF(env, res);
    
    free(res);
    
    return jres;
}

jobject caller;
JNIEnv* calling_env;

void outter_func(chars_t buffer, int size)
{   
    if (size < 0)
    {
        size = STRLEN (buffer);
    }

    jstring jres = (*calling_env)->NewStringJni(calling_env, buffer, size);
    jclass cls = (*calling_env)->GetObjectClass(calling_env, caller);
    jmethodID jPrintResult = (*calling_env)->GetMethodID(calling_env, cls, "printCompilerResult", "(Ljava/lang/String;)V");
    if (jPrintResult == NULL)
    {
		fprintf (stderr, "Cannot find printCompilerResult function\n");
    }
	else
    {
	    (*calling_env)->CallVoidMethod (calling_env, caller, jPrintResult, jres);
    }
}

JNIEXPORT void JNICALL Java_JNIConnector_callCompiler(JNIEnv *env, jobject obj, jstring command) {
    chars_t str1 = (chars_t)(*env)->GetStringCharsJni(env, command, 0);
    init_compiler(outter_func,0/*must be fixed*/);
    caller = obj;
    calling_env = env;
    run_source(str1);

    (*env)->ReleaseStringJni(env, command, str1);
    finit_compiler();
}

int main() { return 0; }
