#define LIB_DLL_EXPORT 1
#include "testlib.h"

void initialize_lib();

#if defined(WINDOWS)
#include "windows.h"
BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpReserved )  // reserved
{
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
        case DLL_THREAD_ATTACH:
            initialize_lib();
            break;
        case DLL_THREAD_DETACH:
        case DLL_PROCESS_DETACH:
            break;
    }
    return TRUE;
}
#else
#pragma CALL_ON_LOAD initialize_lib
#endif



LIB_API
void initialize_lib()
{
  // code to initialize the library (if needed)
}

LIB_API unsigned char addub( unsigned char x, unsigned char y )
{
    return x+y;
}

LIB_API unsigned short addus( unsigned short x, unsigned short y )
{
    return x+y;
}

LIB_API unsigned int adduw( unsigned int x, unsigned int y )
{
    return x+y;
}

LIB_API uint64_t addud( uint64_t x, uint64_t y )
{
    return x+y;
}

LIB_API char addib( char x, char y )
{
    return x+y;
}

LIB_API short addis( short x, short y )
{
    return x+y;
}

LIB_API int addiw( int x, int y )
{
    return x+y;
}

LIB_API int64_t addid( int64_t x, int64_t y )
{
    return x+y;
}

LIB_API int apply( fn_t function, int x, int y )
{
  return function(x,y);
}

LIB_API int asciichar( char* s )
{
  return *s;
}
