#ifndef _TESTLIB_HEADER_INCLUDED
#define _TESTLIB_HEADER_INCLUDED

#if defined(WINDOWS)
#  if defined(LIB_DLL_EXPORT)
#    define LIB_API __declspec(dllexport)
#  else
#    define LIB_API __declspec(dllimport)
#  endif
#else
#  if defined(LIB_DLL_EXPORT)
#    define LIB_API __attribute__((visibility("default")))
#  else
#    define LIB_API
#  endif
#endif


#include "stdint.h"

typedef int(*fn_t)(int, int);


LIB_API
void initialize_lib();

LIB_API unsigned char  addub( unsigned char  x, unsigned char  y );
LIB_API unsigned short addus( unsigned short x, unsigned short y );
LIB_API unsigned int   adduw( unsigned int   x, unsigned int   y );
LIB_API uint64_t       addud( uint64_t x, uint64_t y );

LIB_API char     addib( char    x, char    y );
LIB_API short    addis( short   x, short   y );
LIB_API int      addiw( int     x, int     y );
LIB_API int64_t  addid( int64_t x, int64_t y );

LIB_API int apply( fn_t function, int x, int y );

#endif //_TESTLIB_HEADER_INCLUDED
